
Include "HjGlobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; default HJ constants
include "MSAAConst.jsh"
Include "HjHelp.jsh" ; Help Topic Constants
include "winstyles.jsh"
include "uia.jsh"
Include "common.jsm" ; message file

globals
	object UIAApp,
	VariantArray tempArray,
	VariantArray theTabArray


Void Function SpeakElements (handle foo, int condition)
var
	object oGroups,
	object children,
	object element,
	object UIAApp = CreateObjectEx ("FreedomSci.UIA", false, "UIAScriptAPI.x.manifest" ),
	object TW,
	Variant condition1 = UIAApp.RawViewCondition,
	Variant condition2 = UIAApp.ControlViewCondition,
	Variant condition3 = UIAApp.ContentViewCondition,
	Variant cond,
	int i,
	int z,
	string text,
	string NL,
	string tmp

if condition == 1 then
	cond = UIAApp.RawViewCondition
	TW = UIAApp.RawViewWalker
ElIf condition == 2 then
	cond = UIAApp.ControlViewCondition
	TW = UIAApp.ControlViewWalker
Else
	cond = UIAApp.ContentViewCondition
	TW = UIAApp.ContentViewWalker
EndIf

TW.CurrentElement = UIAApp.GetElementFromHandle(foo)
oGroups = TW.CurrentElement.FindAll (TreeScope_descendants, cond )

NL = "\n"
tmp = IntToString( oGroups.count )
text = "Number of elements: " + tmp + NL + NL
For i = 0 to oGroups.count-1
	if IsKeyWaiting () then
		return
	endif

text = text + "Item #" + IntToString(i) + NL
tmp = oGroups(i).GetLegacyIAccessiblePattern().KeyboardShortcut
text = text + "GetLegacyIAccessiblePattern().KeyboardShortcut = " + tmp + NL
tmp = oGroups(i).GetLegacyIAccessiblePattern().name
text = text + "GetLegacyIAccessiblePattern().name = " + tmp + NL
tmp = oGroups(i).GetLegacyIAccessiblePattern().automationID
text = text + "GetLegacyIAccessiblePattern().automationID = " + tmp + NL
tmp = oGroups(i).GetLegacyIAccessiblePattern().value 
text = text + "GetLegacyIAccessiblePattern().value = " + tmp + NL
tmp = oGroups(i).GetLegacyIAccessiblePattern().description 
text = text + "GetLegacyIAccessiblePattern().description = " + tmp + NL
tmp = oGroups(i).helpText 
text = text + "helpText = " + tmp + NL
tmp = oGroups(i).localizedControlType 
text = text + "localizedControlType = " + tmp + NL
tmp = oGroups(i).AccessKey
text = text + "AccessKey = " + tmp + NL
tmp = oGroups(i).ClassName
text = text + "Class Name = " + tmp + NL
tmp = IntToString( oGroups(i).IsContentElement )
text = text + "IsContentElement= " + tmp + NL
tmp = IntToString( oGroups(i).IsControlElement )
text = text + "IsControlElement= " + tmp + NL
tmp = IntToString( oGroups(i).IsKeyboardFocusable )
text = text + "IsKeyboardFocusable= " + tmp + NL
tmp = oGroups(i).ItemType
text = text + "ItemType= " + tmp + NL
tmp = oGroups(i).LabeledBy
text = text + "LabeledBy= " + tmp + NL
tmp = oGroups(i).Name
text = text + "Name= " + tmp + NL
text = text + NL

;children = oGroups(i).FindAll (TreeScope_children, condition1)
;for z = 0 to children.count
;do something here
;endFor

EndFor

SayMessage (OT_USER_BUFFER, text, text)
PCCursor ()
SayString("done")

EndFunction


Void Function CreateList ( handle foo,  int condition )
var
	object UIAApp = CreateObjectEx ("FreedomSci.UIA", false, "UIAScriptAPI.x.manifest" ),
	object OGroups,
	Variant choices,
	object TW,
	Variant condition1 = UIAApp.RawViewCondition,
	Variant condition2 = UIAApp.ControlViewCondition,
	Variant condition3 = UIAApp.ContentViewCondition,
	Variant cond,
	int i,
	int c

if condition == 1 then
	cond = UIAApp.RawViewCondition
	TW = UIAApp.RawViewWalker
ElIf condition == 2 then
	cond = UIAApp.ControlViewCondition
	TW = UIAApp.ControlViewWalker
Else
	cond = UIAApp.ContentViewCondition
	TW = UIAApp.ContentViewWalker
EndIf

TW.CurrentElement = UIAApp.GetElementFromHandle(foo)
oGroups = TW.CurrentElement.FindAll (TreeScope_descendants, cond )

SayString( "Number of elements = " )
SayString( oGroups.count )

;oGroups = TW.CurrentElement.GetChildren(TreeScope_descendants, cond )
;Saystring("The handle is " + IntToString(foo) + " and the number of elements is " )
;Sayinteger(oGroups.count)

tempArray = new VariantArray[oGroups.count,1]
For I = 0 to oGroups.count-1
let c = c+1
tempArray[I,1] = oGroups(i)
if choices == "" then
let choices = oGroups(i).name
else
let choices = choices+"|"+oGroups(i).name
endif
EndFor
theTabArray = new VariantArray[c,1]
for I = 0 to c
theTabArray[I,1] = tempArray[I,1]
EndFor
let I = DLGSelectItemInList(choices,"",0,1)
if I != 0 then
theTabArray[I,1].SetFocus()
endif

;This example will allow you to create arrays that can be called later on and presents a dialog for them to pick an object and focus on it. 


;In the above example, I use the c = c+1 statement counter. This is for when you make conditions such as:
;if oGroups(i).controlType == 50033 then
;let c= c+1
;let tempArray[c,1] = oGroups(i)
;endif
;Then in the next for loop you take out all the empty places in the array since we declared the array as a fixed number.
;To use this array in a tab order you can make your own tab script with a global counter.
;example:
;let tabOrder = tabOrder+1
;if !theTabArray[tabOrder,1] then
;let tabOrder = 1
;endif
;theTabArray[tabOrder,1].SetFocus()
;and for the shift tab:
;let tabOrder = tabOrder-1
;if !theTabArray then
;TabOrder = ArrayLength(theTabArray)
;endif
;Now you can tab and shift tab through your object array.




EndFunction





